#!/usr/bin/webif-page
<?

###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This Script is based on the original La Fonera Firmware version 0.7.1r2
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /usr/lib/webif/webif.sh

validate <<EOF
string|FORM_submit|@TR<<Submit>>|max=10|$FORM_submit
EOF

if [ "$?" != "0" ]
then
	FORM_submit=""
fi

ff_file=/etc/config/localusers.txt
localusers=/etc/config/localusers
touch $ff_file
touch $localusers


load_settings fon
if empty "$FORM_submit"; then
	get_default ssid public essid
else
	validate <<EOF
string|FORM_ssid|@TR<<SSID>>|required max=28|$FORM_ssid
EOF
	equal "$?" 0 && {
		save_setting fon public essid "$FORM_ssid"
		commit_settings
		SAVED=1
	}
	enabled $FORM_enable || {
		save_setting qos hotspot enabled "$FORM_enable"
		commit_settings
	 	/usr/bin/qos-stop
	}
fi

config_load qos
config_load family_and_friends
if empty "$FORM_submit"; then
	get_default ffenable ff enable
	get_default enable hotspot enabled
	get_default upload hotspot upload
	get_default download hotspot download
else
	[ "$FORM_ffuser" != "" -a "$FORM_ffpass" != "" ] && {
		echo $FORM_ffuser:$FORM_ffpass >>$ff_file
	}
	enabled $FORM_ffenable && \
	validate <<EOF
bool|FORM_ffenable|@TR<<Family and Friends>>|required|$FORM_ffenable
EOF
	equal "$?" 0  && {
		save_setting family_and_friends ff enable "$FORM_ffenable"
		commit_settings
		cat $ff_file > $localusers
		killall -HUP chilli
		unset FORM_ffuser FORM_ffpass
	}
	enabled $FORM_enable && \
	validate <<EOF
bool|FORM_enable|@TR<<Bandwidth Limit>>|required|$FORM_enable
EOF
	equal "$?" 0  && {
		save_setting qos hotspot enabled "$FORM_enable"
		save_setting qos hotspot upload "$FORM_upload"
		save_setting qos hotspot download "$FORM_download"
		commit_settings
		if enabled $FORM_enable; then
			/usr/bin/qos-start
		 else
		 	/usr/bin/qos-stop
		fi
		SAVED=1
	} 
	enabled $FORM_enable || {
		save_setting qos hotspot enabled "$FORM_enable"
		commit_settings
	 	/usr/bin/qos-stop
	}
	enabled $FORM_ffenable || {
		save_setting family_and_friends ff enable "$FORM_ffenable"
		commit_settings
		>$localusers
		killall -HUP chilli 2>/dev/null
	}


fi


header "Pub_Title#Public Wireless Settings"

display_form <<EOF
	infotable|PRE_PUB_SSID#This is the name of the signal the rest of the foneros will connect to. It will be automatically prefixed with the 'FON_' string.
	start_table|0|10|5
		add_row
			add_label_cell|@TR<<SSID#Signal name (SSID)>>|FON_
			add_input_cell|ssid|$FORM_ssid|tableTextButton
		end_row
		add_row
			add_button_cell|submit|@TR<<Submit>>
		end_row
	end_table

	infotable|Bandwidth Limit
	infotable|Advanced_Bandwidth#Set a Bandwidth Limit for the public signal.
EOF
cat <<EOF
<script language="Javascript1.5" type="text/javascript">
<!--
function bwchange() {
	set_visible('bw', isset('enable', '1'));
}
function ffchange() {
	set_visible('ff', isset('ffenable', '1'));
}
-->
</script>
EOF
display_form <<EOF
	start_table|0|10|5
		onchange|bwchange
		add_row
			add_label_cell|@TR<<Bandwidth Limit>>
			start_select_cell|enable|$FORM_enable|tableTextSelect
				option|0|@TR<<Disabled>>
				option|1|@TR<<Enabled>>
			end_select_cell
		end_row
	end_table
	start_div|bw
	start_table|0|10|5
		add_row
			add_label_cell|@TR<<Download>> (kBit/s)
			start_select_cell|upload|$FORM_upload|tableTextSelect
				option|4096|4096
				option|2048|2048
				option|1024|1024
				option|512|512
				option|256|256
				option|128|128
				option|64|64
			end_select_cell
		end_row
		add_row
			add_label_cell|@TR<<Upload>> (kBit/s)
			start_select_cell|download|$FORM_download|tableTextSelect
				option|2048|2048
				option|1024|1024
				option|512|512
				option|256|256
				option|192|192
			end_select_cell
	end_table
	end_div
	start_table|0|10|5
		add_row
			add_button_cell|submit|@TR<<Submit>>|tableTextButton
		end_row
	end_table

	infotable|Family and Friends
	infotable|Advanced_Family_and_Friends#Set Username and Passwords for Users they could use the public signal free of charge. The username and password should have 4 characters as minimum.
	start_table|0|10|5
	draw_line
	end_table

        start_table|0|10|5
                onchange|ffchange
                add_row
                        add_label_cell|@TR<<Family and Friends>>
                        start_select_cell|ffenable|$FORM_ffenable|tableTextSelect
                                option|0|@TR<<Disabled>>
                                option|1|@TR<<Enabled>>
                        end_select_cell
                end_row
        end_table
        start_div|ff
        start_table|0|10|5
		add_row
			add_normal_cell|&nbsp;
			add_normal_cell|<b>@TR<<User>></b>
			add_normal_cell|<b>@TR<<Password>></b>
		end_row
EOF
        c=0;
	lines=`wc -l $ff_file`
	lines=${lines% *}
        if [ $lines != 0 ];then
         for pair in `cat $ff_file`;do
          c=$((c+1))
	  user=`echo $pair|cut -d: -f1`
	  pass=`echo $pair|cut -d: -f2`
          display_form <<EOF
                add_row
			add_normal_cell|&nbsp;
                        add_normal_cell|$user
                        add_normal_cell|$pass
                        add_normal_cell|<a href="/cgi-bin/webif/line_add_del.sh?ACTION=ff&ADDDEL=2&CONTENT=$user:$pass">@TR<<Delete>></a>
                end_row
EOF
         done
        fi
	display_form <<EOF
		add_row
			add_label_cell|@TR<<New User>>:
			add_input_cell|ffuser|$FORM_ffuser|tableTextButton
			add_input_cell|ffpass|$FORM_ffpass|tableTextButton
		end_row
        end_table
        end_div
        start_table|0|10|5
                add_row
                        add_button_cell|submit|@TR<<Submit>>|tableTextButton
                end_row
        end_table


	help|public
	call_js|bwchange
	call_js|ffchange
EOF


footer ?>