#!/usr/bin/webif-page
<?

###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /usr/lib/webif/webif.sh
sel_uamallow=1

validate <<EOF
string|FORM_submit|@TR<<Submit>>|max=10|$FORM_submit
EOF

. /usr/lib/webif/advanced.sh

textfile=/etc/config/uamallow.txt
tmpfile=/tmp/uamallow.txt
chillifile=/etc/chilli.allowed
touch $textfile
touch $tmpfile
lines=0
initbutton=1
actiondone=0
freewlan_check=1

check_freewlan() {
	testurl=`cat $textfile | grep -i "www.freewlan.info"`
	if [ "$testurl" = "" ]; then
		echo "www.freewlan.info" >>$textfile
	fi
	testurl=`cat $textfile | grep -i "de.freewlan.info"`
	if [ "$testurl" = "" ]; then
		echo "de.freewlan.info" >>$textfile
	fi
}

sep() {
  OIFS=$IFS
  IFS=','
  for i in $*;do
    echo $i;
  done
  IFS=$OIFS
}

chilli_restart() {
  /etc/init.d/N50chillispot radconfig
  killall chilli 2>/dev/null
}

reset_list_to_chilli_defaults() {
         get_default enable main enable
         save_setting uamallow main enable "0"
         commit_settings
         /etc/init.d/N50chillispot radconfig
         save_setting uamallow main enable "1"
         commit_settings
         FORM_enable="1"
         grep ^uamallowed /etc/chilli.conf |while read s;do
                sep $s
         done|grep -v uamallowed |sort -r >$textfile
}

config_load uamallow

empty "$FORM_delete" || {
	cp $textfile $tmpfile
	FORM_enable=1
	FORM_submit=1
	FORM_newentry=""
	initbutton=1
	resetbutton=1
	appendbutton=0
	actiondone=1
	freewlan_check=1
}

empty "$FORM_init" || {
	cp $textfile $tmpfile
	reset_list_to_chilli_defaults
	FORM_enable=1
	FORM_submit=1
	initbutton=0
	resetbutton=1
	appendbutton=1
	actiondone=1
	freewlan_check=0
}

empty "$FORM_reset" || {
	cp $tmpfile $textfile
	FORM_enable=1
	FORM_submit=1
	initbutton=1
	resetbutton=0
	appendbutton=0
	actiondone=0
	freewlan_check=0
}

empty "$FORM_append" || {
	cat $tmpfile $textfile >/tmp/uamallow_append.txt
	mv /tmp/uamallow_append.txt $textfile
	FORM_enable=1
	FORM_submit=1
	initbutton=0
	resetbutton=1
	appendbutton=0
	actiondone=1
	freewlan_check=0
}

if empty "$FORM_submit"; then
	get_default enable main enable
else
	enabled $FORM_enable || {
	>$chillifile
	#>$textfile
	}
	c=0;
	if enabled $FORM_enable;then
		save=1
		if [ "x$FORM_newentry" != "x" ];then
			validate <<EOF
string|FORM_newentry|@TR<<Hostname>>|required|$FORM_newentry
EOF
			if [ $? = 0 ];then
				echo $FORM_newentry >>$textfile
				FORM_newentry=""
			fi
		else
			## checking number of lines
			c=`cat $textfile | wc -l`; c=${c##* }
	
			## checking lines to delete
			while  [ $c != "0" ]; do
			eval FORM="\$FORM_uam$c"
			if  [ "$FORM" = "checked" ]; then
				sed -e "${c}D" -i $textfile
				lines=$((lines-1))
			fi
			c=$((c-1))
			done
		fi
		[ $save = 1 -a $FORM_enable = 1 ] && lines=$((lines+1))
	fi
	if [ "$actiondone" = "0" ]; then
		test -f "$tmpfile" && rm -f "$tmpfile"
	fi
fi # FORM_submit

empty "$FORM_submit" || {
	save_setting uamallow main enable "$FORM_enable"
	commit_settings
	SAVED=1
}

enabled $FORM_enable && { 
 lines=`wc -l $textfile`;
 lines=${lines% *};
}

if [ "$freewlan_check" = "1" ]; then
	check_freewlan
fi

header "Additional Hostnames"

cat <<EOF
<script language="Javascript1.5" type="text/javascript">
<!--
function enablechange() {
		set_visible('enabled', isset('enable', '1'));
}
function buttons( showbuttons ) {
	if (showbuttons == 0) {
		set_visible('buttons', 0);
	}
	if (showbuttons == 1) {
		window.setTimeout("set_visible('buttons', 1)", 2000);
	}
}
-->
</script>
EOF
display_form <<EOF
	infotable|Advanced_uamallow#Here you can set IP Addresses or Hostnames they can used additionaly by unauthenticated users. Please notice that it may be possible, that unauthorized and anonymous internet access could be given.
        start_table|0|10|5
                onchange|enablechange
                add_row
                        add_label_cell|@TR<<Additional Hostnames>>
                        start_select_cell|enable|$FORM_enable|tableTextSelect
                                option|0|@TR<<Disabled>>
                                option|1|@TR<<Enabled>>
                        end_select_cell
                end_row
        end_table
	start_table|0|10|5
		add_row
			add_button_cell|submit|@TR<<Submit>>|tableTextButton
		end_row
	end_table
	start_div|enabled
	start_div|buttons
	start_table|0|10|5
		add_row
EOF
if [ "$initbutton" = "1" ]; then
display_form <<EOF
			add_button_cell|init|@TR<<Get FON Defaults>>|tableTextButton
EOF
else
display_form <<EOF
			add_label_cell
EOF
fi

if [ "$resetbutton" = "1" ]; then
display_form <<EOF
			add_button_cell|reset|@TR<<Back to previous list>>|tableTextButton
EOF
else
display_form <<EOF
			add_lebel_cell
EOF
fi

if [ "$appendbutton" = "1" ]; then
display_form <<EOF
			add_button_cell|append|@TR<<Append to previous list>>|tableTextButton
EOF
fi

display_form <<EOF
		end_row
	end_table
	end_div
	call_js|buttons|0
	start_table|0|0|0
	add_row
		add_label_cell
		add_label_cell
		add_label_cell|@TR<<check to delete>>:
	end_row
EOF
	c=0;
	if [ $lines != 0 ];then
	 for string in `cat $textfile`;do
  	  c=$((c+1))
	  display_form <<EOF
		add_row
			add_label_cell|@TR<<IP / Host>> $c:
			add_normal_cell|<b>$string</b>
			add_checkbox_cell|uam$c||checked
		end_row
EOF
	 done
	fi
display_form <<EOF
		add_row
			add_label_cell|@TR<<add IP/ Host>>:
			add_input_cell|newentry|$FORM_newentry|tableTextButton
		end_row
	end_table
	start_table|0|10|5
		add_row
			add_button_cell|submit|@TR<<Submit>>|tableTextButton
			add_label_cell
			add_label_cell
			add_button_cell|delete|@TR<<Delete>>|tableTextButton
		end_row
	end_table
	end_div
	help|uamallow
	call_js|enablechange
	call_js|buttons|1
EOF
[ "$SAVED" = "1" ] && {
 >$chillifile
 
 if enabled $FORM_enable;then
   cat $textfile|while read host;do
      echo "uamallowed $host" >>$chillifile
   done
 fi
 chilli_restart
}
enabled $FORM_enable || {
	>$chillifile
}
footer ?>